var lWarn = {logln:function (o){}}; 
var lInfo = {logln:function (o){}};

var LOGFILE_NAME = "ps-config.log";
lWarn = new Logger(LOGFILE_NAME);
lInfo = new Logger(LOGFILE_NAME);

function storeSubParameter(path, value) {
    try 
    {
        lInfo.logln("StoreSubParameter Path " + path  + " value " + value + " type " + typeof(value));
        Property.setProperty('entries/' + path, value);
        Property.setFlag('entries/' + path, 'ARCHIVE', true);
    }
    catch (e)
    {
        lWarn.logln("Fehler beim StoreSubParameter " + e + " Path " + path  + " value " + value);
    }        
}

function getNewTEIdValue() {
    var idValue = 0;
    var baseNode = Property.getNode('/scripts/system-addon-timed-events/entries');
    if (baseNode == null)
        return idValue;
    var oArrayNode = baseNode.getChildren();
    for ( var iIndex = 0; iIndex < oArrayNode.length; iIndex++) {
        var oChildNode = oArrayNode[iIndex];
        if (oChildNode.getChild('id') != null)
            if (oChildNode.getChild('id').getValue() != null)
                if (parseInt("" + oChildNode.getChild('id').getValue(),10) >= idValue)
                    idValue = parseInt("" + oChildNode.getChild('id').getValue(),10) + 1;
    }
    return idValue;
}


function loadOldValue(path,newID) {
    var oResult={};
    var oObject=Property.getNode(path);
    try {        
        oResult.name=oObject.getChild('name').getValue();        
        if (oObject.getChild('maxdiv')!=null)
            if (oObject.getChild('maxdiv').getValue()!=null)
                if (oObject.getChild('maxdiv').getValue()!='undefined')
                    oResult.random=parseInt(oObject.getChild('maxdiv').getValue(),10);
        
        // actions
        if (oObject.getChild('actions')!=null) {
            var oActionArray=oObject.getChild('actions').getChildren();
            oResult.actions=[];
            for (var iIndex=0;iIndex<oActionArray.length;iIndex++) {
                var oActionObject={};
                var oParameterArray=oActionArray[iIndex].getChildren();
                oActionObject.force=false;
                oActionObject.type='zone-scene';
                for (var jIndex=0;jIndex<oParameterArray.length;jIndex++) {
                    oActionObject[oParameterArray[jIndex].getName()]=oParameterArray[jIndex].getValue();
                }
                if (oActionObject.delay!=null)
                    oActionObject.delay=oActionObject.delay*60;
                oResult.actions.push(oActionObject);
            }        
        }
        // time
        oResult.time={};
        if (oObject.getChild('time')!=null)
        {
            lInfo.logln('node has time entry');
            var oTime=new Date(parseInt(''+oObject.getChild('time').getValue(),10)*1000);
            oResult.time.offset=oTime.getHours()*3600 + oTime.getMinutes()*60;
            oResult.time.timeBase="daily";
            
        }
        if (oObject.getChild('sunrise')!=null)
        {
            lInfo.logln('node has sunrise entry');
            oResult.time.offset=parseInt(''+oObject.getChild('sunrise').getValue(),10);
            oResult.time.timeBase="sunrise";
        }
        if (oObject.getChild('sunset')!=null)
        {
            lInfo.logln('node has sunset entry');
            oResult.time.offset=parseInt(''+oObject.getChild('sunset').getValue(),10);
            oResult.time.timeBase="sunset";
        }
        if (oObject.getChild('holidayStart')!=null)
        {
            lInfo.logln('node has holidayStart entry');
            oResult.time.offset=parseInt(''+oObject.getChild('holidayStart').getValue(),10);
            oResult.time.timeBase="beforeHoliday";
            oResult.time.propertyReference="/scripts/system-addon-presence-simulator/values/holiday/*/von"
        }
        if (oObject.getChild('holidayEnd')!=null)
        {
            lInfo.logln('node has holidayEnd entry');
            oResult.time.offset=parseInt(''+oObject.getChild('holidayEnd').getValue(),10);
            oResult.time.timeBase="afterHoliday";
            oResult.time.propertyReference="/scripts/system-addon-presence-simulator/values/holiday/*/bis"
        }
                
        // recurrence
        oResult.recurrence={};
        oResult.recurrence.timeArray=[];
        oResult.recurrence.recurrenceBase='weekly';
        var oRecurrenceArray=oObject.getChild('recurrence').getChildren();
        for (var iIndex=0;iIndex<oRecurrenceArray.length;iIndex++) {
            oResult.recurrence.timeArray.push(oRecurrenceArray[iIndex].getValue());
        }

        Property.setProperty('/scripts/system-addon-presence-simulator/entries/' + newID, newID);
        Property.setFlag('/scripts/system-addon-presence-simulator/entries/' + newID, 'ARCHIVE', true);
        oResult.id=newID;
        lInfo.logln('raise Event: ' + JSON.stringify(oResult));
        
        var sNewValue = escape(JSON.stringify(oResult));
        var evt = new Event("system-addon-timed-events.config", {actions:'save',value:sNewValue});
        evt.raise();
        
        if (oObject.getChild('disabled').getValue()) {
            var evt = new Event("system-addon-timed-events.config", {actions:'disable',id:newID,time:'+10'});
            evt.raise();
        }
        lInfo.logln('remove sub node');
        Property.getNode('values/actions').removeChild(oObject.getName());
    } 
    catch (e) {
        lWarn.logln("Fehler bei Migration" + path + " : " + e)
    }
}

function updateData() {
    lInfo.logln('start Update');
    Property.load();
    try {
        var oldValues=Property.getNode('values/actions');
        var iNewID=getNewTEIdValue();
        if (oldValues!=null) {
            var oOldArray=oldValues.getChildren();
            lInfo.logln('oldvalues found ' + oOldArray.length);
            for (var iIndex=0;iIndex<oOldArray.length;iIndex++) {
                lInfo.logln('mach #' + iIndex + " : " +oOldArray[iIndex].getPath());
                loadOldValue(oOldArray[iIndex].getPath(),iNewID);
                iNewID++;
            }
            if (oldValues.getChildren().length==0) {
                lInfo.logln('remove main node');
                Property.getNode('values').removeChild('actions');
            }
        } else 
            lInfo.logln('no old values found');
        Property.store();
    } catch (e) {
        lWarn.logln('Error beim Update Data ' + e);
    }
    var evt = new Event("system-addon-presence-simulator.te-config", {actions:'syncTE'});
    evt.raise();
    var evt = new Event("system-addon-presence-simulator",  {actions:'checkHoliday'});
    evt.raise();   
}

updateData();